using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class PagerLinkSelector : System.Web.UI.UserControl
{
	// Public Fields

	public int RecordCount = 0;	// Set by Control Owner
	public int NumberOfPages = 0; // Set by Control Owner
	public int PageLinksPerSection = 5;	// Default value for Max Number of Visible Page Links at a time.
	public Axezz.WebControls.AxpDataGrid ConnectedGrid;	// AxpDataGrid connected to this pager

	// Private Fields

	private string previousPageText = "";
	private string previousPageToolTip = "Previous Page";

	private string nextPageText = "";
	private string nextPageToolTip = "Next Page";

	private string firstPageText = "First";
	private string firstPageToolTip = "First Page";

	private string lastPageText = "Last";
	private string lastPageToolTip = "Last Page";

	private int fromPageLink;
	private int toPageLink;

  protected void Page_Load(object sender, EventArgs e)
  {
  }

	public void FillPager()
	{
		InitializePager();
		SetPagerItems();
		LinkSelector1.SelectedItem = (ConnectedGrid.CurrentPageIndex + 1).ToString();
	}

	private void InitializePager()
	{
		// Establish from - to page links
		fromPageLink = ((ConnectedGrid.CurrentPageIndex / PageLinksPerSection) * PageLinksPerSection) + 1;
		toPageLink = fromPageLink + PageLinksPerSection - 1;

		if (toPageLink > NumberOfPages)
			toPageLink = NumberOfPages;
		// Disable pager when grid is in Edit mode (not needed, but probably more user friendly)
		LinkSelector1.Enabled = (ConnectedGrid.CurrentMode != "formedit");
	}

	private void SetPagerItems()
	{
		// Set LinkSelector Items

		// Clear and fill the items on each postback.
		LinkSelector1.LinkItems.Clear();

		// Only fill LinkSelector if number of pages is > 1 as it does not make much sense 
		// to have 0 or 1 page items in the pager.
		if (NumberOfPages > 1)
		{
			// First page
			Axezz.WebGadgets.LinkItem liFirst = new Axezz.WebGadgets.LinkItem(firstPageText);
			liFirst.ToolTip = firstPageToolTip;
			LinkSelector1.LinkItems.Add(liFirst);

			// Previous page
			Axezz.WebGadgets.LinkItem liPrevious = new Axezz.WebGadgets.LinkItem(previousPageText);
			liPrevious.ToolTip = previousPageToolTip;
			liPrevious.Enabled = (ConnectedGrid.CurrentPageIndex > 0);
			LinkSelector1.LinkItems.Add(liPrevious);

			// Page number links
			for (int i = fromPageLink; i <= toPageLink; i++)
				LinkSelector1.LinkItems.Add(new Axezz.WebGadgets.LinkItem(i.ToString()));

			// Next page
			Axezz.WebGadgets.LinkItem liNext = new Axezz.WebGadgets.LinkItem(nextPageText);
			liNext.ToolTip = nextPageToolTip;
			liNext.Enabled = (ConnectedGrid.CurrentPageIndex < (NumberOfPages) - 1);
			LinkSelector1.LinkItems.Add(liNext);

			// Last page
			Axezz.WebGadgets.LinkItem liLast = new Axezz.WebGadgets.LinkItem(lastPageText);
			liLast.ToolTip = lastPageToolTip;
			LinkSelector1.LinkItems.Add(liLast);
		}
	}

	protected void LinkSelector1_Click(object sender, EventArgs e)
	{
		if (LinkSelector1.SelectedItem == firstPageText)
			ConnectedGrid.CurrentPageIndex = 0;
		else if (LinkSelector1.SelectedItem == previousPageText)
			ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex - 1;
		else if (LinkSelector1.SelectedItem == nextPageText)
			ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex + 1;
		else if (LinkSelector1.SelectedItem == lastPageText)
			ConnectedGrid.CurrentPageIndex = NumberOfPages - 1;
		else
			ConnectedGrid.CurrentPageIndex = int.Parse(LinkSelector1.SelectedItem) - 1;
	}

}
