using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample08 : System.Web.UI.Page
{
	protected string ProductId = string.Empty;

  protected void Page_Load(object sender, EventArgs e)
  {
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

		AxpDataGrid1.SQL = "SELECT * FROM Products";
		AxpDataGrid1.GridCellWidths = "100";
		AxpDataGrid1.DisplayType = "grid";
		AxpDataGrid1.DisplayNavBar = "top";
		AxpDataGrid1.GridDisplayIndex = false;
		AxpDataGrid1.GridFieldsShow = "2";
		AxpDataGrid1.OrderByFields = "2";
		AxpDataGrid1.GridFreeFormatCellDataFieldDelimiter = "%";	 // handy since we are using a dummy html anchor below
		AxpDataGrid1.SetGridFreeFormatCellByCol(2, "<a class=\"AXDBTable\" href=\"#\" onclick=\"return(setLinkField('%ProductId%'))\">%ProductName%</a>");
  }

	protected void AxpDataGrid1_Load(object sender, EventArgs e)
	{
		AxpDataGrid2.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];


		if (Request["ProductId"] != null)
		{
			ProductId = Request["ProductId"];
			if (Session["ProductId"].ToString() != ProductId)
				AxpDataGrid2.ClearState = true;
		}
		else
		{
			if (AxpDataGrid1.CurrentDataView.Count > 0)
				ProductId = AxpDataGrid1.CurrentDataView[0]["ProductId"].ToString();
		}

		Session["ProductId"] = ProductId;

		AxpDataGrid2.SQL = "Select * FROM Products";
		if (ProductId != string.Empty)
			AxpDataGrid2.SQL += " WHERE ProductId=" + ProductId;

		AxpDataGrid2.EditSQL = "Select * FROM Products";		 // Always simplify the table Edit Sql to "select * from tablename"
		AxpDataGrid2.DeleteSQL = "Delete From Products";		 // Required if Delete is enabled
		AxpDataGrid2.DisplayType = "form";
		AxpDataGrid2.EditOptions = "ALL NOVIEW";
		AxpDataGrid2.FormFieldsHide = "ProductId";
		AxpDataGrid2.EditNewPKStatement = "autoincrement";
		AxpDataGrid2.EditPrimaryKeys = "ProductId";
		AxpDataGrid2.FormCellWidths = "100,300";
		AxpDataGrid2.DisplayNavBar = "none";
		AxpDataGrid2.DisplayRecordsPerPageSelect = false;
		AxpDataGrid2.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", false);
		AxpDataGrid2.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", false);

		// Setting Productname to a required field since the grid is unable to detect it on some Access databases
		Axezz.WebControls.EditFieldItem efi = new Axezz.WebControls.EditFieldItem();
		efi.ColumnName = "ProductName";
		efi.Required = true;
		AxpDataGrid2.SetEditField(efi);
	}

	private void RefreshGrid1()
	{
		AxpDataGrid1.UseDataBinding = true;
		AxpDataGrid1.AxConnection.Connection.Close();
		AxpDataGrid1.AxConnection.Connection.Open();
		AxpDataGrid1.RecordCount = -1; // force a recount 
		AxpDataGrid1.DataBind();
		AxpDataGrid1.UseDataBinding = false;
	}

	protected void AxpDataGrid2_InsertClick(object sender, EventArgs e)
	{
		RefreshGrid1();
	}
	protected void AxpDataGrid2_UpdateClick(object sender, EventArgs e)
	{
		RefreshGrid1();
	}
	protected void AxpDataGrid2_DeleteClick(object sender, EventArgs e)
	{
		RefreshGrid1();
	}
}
