using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample09 : System.Web.UI.Page
{
	protected string CustomerId = string.Empty;

	private string PrevCustId
	{
		get
		{
			if (ViewState["PrevCustId"] != null)
				return ViewState["PrevCustId"].ToString();
			else
				return "";
		}
		set { ViewState["PrevCustId"] = value; }
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
		AxpDataGrid1.SQL = "SELECT CustomerId,CompanyName FROM Customers";
		AxpDataGrid1.GridCellWidths = "0,160";
		AxpDataGrid1.DisplayType = "grid";
		AxpDataGrid1.DisplayNavBar = "top";
		AxpDataGrid1.GridDisplayIndex = false;
		AxpDataGrid1.GridFieldsShow = "2";
		AxpDataGrid1.OrderByFields = "2";
		AxpDataGrid1.GridColsNoSort = "*";
		AxpDataGrid1.SetGridFreeFormatCellByCol(2, "<a class=\"AXDBTable\" href=\"\" onclick=\"return(setLinkField('#CustomerId#'))\">#CompanyName#</a>");
	}

	protected void AxpDataGrid1_Load(object sender, EventArgs e)
	{
		// AxpDataGrid2 (Orders Grid and Edit form)
		AxpDataGrid2.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

		// on initial page display we fetch the current CustomerId from the master grid to the detail grid
		// from the first row of the grid : AxpDataGrid1.CurrentDataView[0]["CustomerId"].ToString()
		if (CustomerId == String.Empty)
		{
			if (AxpDataGrid1.CurrentDataView.Count > 0)
			{
				CustomerId = AxpDataGrid1.CurrentDataView[0]["CustomerId"].ToString();
			}
		}

		// We keep track of the prev CustomerId used so we can clear the state of the detail grid when CustomerId change
		// Not strictly needed but nice to have...
		if (Request["CustomerId"] != null)
		{
			CustomerId = Request["CustomerId"];
			if (CustomerId != PrevCustId)
			{
				if (PrevCustId != "")
					AxpDataGrid2.ClearState = true;
				PrevCustId = CustomerId;
			}
		}

		// Construct SQL
		string sql = "Select OrderId, CustomerId, OrderDate, RequiredDate, ShippedDate, Freight FROM Orders";
		if (CustomerId != String.Empty)
			sql = sql + " WHERE CustomerId='" + CustomerId + "'";
		else
			sql = sql + " WHERE 1=2";			// ensures that we get an empty recordset 
		AxpDataGrid2.SQL = sql;

		// For Insert purposes, set the CustomerId default value 
		Axezz.WebControls.EditFieldItem editCustomerIdField = new Axezz.WebControls.EditFieldItem();
		editCustomerIdField.ColumnName = "CustomerId";
		editCustomerIdField.DefaultValue = CustomerId;
		AxpDataGrid2.SetEditField(editCustomerIdField);

		// Then set more standard properties
		AxpDataGrid2.GridFieldsHide = "1";
		AxpDataGrid2.EditSQL = "Select * FROM Orders";		 // Always simplify the table Edit Sql to "select * from tablename"
		AxpDataGrid2.DeleteSQL = "Delete From Orders";		 // Required if Delete is enabled
		AxpDataGrid2.EditOptions = "ALL NOVIEW";
		AxpDataGrid2.EditNewPKStatement = "autoincrement";
		AxpDataGrid2.DisplayExcelIcon = false;
		AxpDataGrid2.EditPrimaryKeys = "OrderID";
		AxpDataGrid2.FormFieldsHide = "1,2";
		AxpDataGrid2.FormCellWidths = "100,400";
		AxpDataGrid2.EditFieldsReadOnly = "1,2";
		AxpDataGrid2.DisplayNavBar = "both";
		AxpDataGrid2.DisplayRecordsPerPageSelect = true;
		AxpDataGrid2.RowRollOverEffect = true;
		AxpDataGrid2.RowClickAction = "openform";
		AxpDataGrid2.GridDisplayIndex = false;
		if (AxpDataGrid2.AxConnection.DatabaseEngine == "ACCESS")
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName & ' ' & LastName", "2", true);
		else
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName + ' ' + LastName", "2", true);
		AxpDataGrid2.AddEditLookup("ShipVia", "Shippers", "ShipperID", "CompanyName", "2", true);
	}
}