using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample16 : System.Web.UI.Page
{
	private string PreviousWhereClause
	{
		get { object o = ViewState["PreviousWhereClause"]; return ((o == null) ? string.Empty : (string)o); }
		set { ViewState["PreviousWhereClause"] = value; }
	}

  protected void Page_Load(object sender, EventArgs e)
  {
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
		// Because WebControls are loaded after the grid, we set the grid property .UseDataBinding = True.
		// We must then call the grid DataBind method after setting other properties.
		// For simplicity in this example we do all the work in the Page PreRender event
		AxpDataGrid1.UseDataBinding = true;
  }

	protected void Page_PreRender(object sender, System.EventArgs e)
	{
		InitGrid();
		AxpDataGrid1.DataBind();
	}

	private void InitGrid()
	{
		string sql = "Select * From Products";
		string whereClause = string.Empty;
		string productNameFilter = ProductName.Text.Trim().Replace("'", "''");
		if (productNameFilter.Length > 0)
			whereClause = string.Format(" Where ProductName Like '{0}%'", productNameFilter);

		if (SupplierID.Text.Trim() != string.Empty)
		{
			Int32 intSupplierId;
			if (Int32.TryParse(SupplierID.Text.Trim(), out intSupplierId))
			{
				if (whereClause == string.Empty)
					whereClause = " Where";
				else
					whereClause = whereClause + " And";

				whereClause = whereClause + " SupplierID=" + intSupplierId.ToString();
			}
		}
		sql = sql + whereClause;
		AxpDataGrid1.SQL = sql;
		if (PreviousWhereClause != sql)
			// We keep the previous sql in a ViewState variable and resets the AxpDataGrid "state" if the SQL has changed.
			AxpDataGrid1.ClearState = true;
		PreviousWhereClause = sql;
	}

}
