using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample18 : System.Web.UI.Page
{
  protected void Page_Load(object sender, EventArgs e)
  {
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
  }

	protected void AxpDataGrid1_Load(object sender, EventArgs e)
	{
		// The properties GridColumns and FormViewColumns is populated and available in the grid's Load event
		AxpDataGrid1.GridColumns["UnitPrice"].FormatCellFunction = "FormatCurrency";
		AxpDataGrid1.GridColumns["UnitPrice"].Wrap = false;

		AxpDataGrid1.GridColumns["QuantityPerUnit"].Wrap = false;
		AxpDataGrid1.GridColumns["SupplierID"].Visible = false;
		AxpDataGrid1.GridColumns["CategoryID"].Visible = false;

		// Notice how formatting is set both for Grid and Form View when GridColumns.FreeFormatCell is set.
		// Ref. the property ApplyCellFormattingToForm
		AxpDataGrid1.GridColumns["ProductID"].FreeFormatCell = "<b style='color:green'>#ProductID#</b>";

		AxpDataGrid1.GridColumns["ProductName"].FreeFormatCell = "<b style='color:green'>#ProductName#</b>";
		// let the same column in Form View have a red color.
		AxpDataGrid1.FormViewColumns["ProductName"].FreeFormatCell = "<b style='color:red'>#ProductName#</b>";

		AxpDataGrid1.FormViewColumns["ProductName"].Caption = "Product Name";
		AxpDataGrid1.FormViewColumns["ProductName"].CellHtmlAttributes = "style='border:1px solid yellow'";
		AxpDataGrid1.FormViewColumns["ProductName"].GridHeadHtmlAttributes = "style='border:1px solid yellow'";

		AxpDataGrid1.FormViewColumns["UnitPrice"].GridHeadHtmlAttributes = "style='background-color:white;font-weight:bold'";
		AxpDataGrid1.FormViewColumns["UnitPrice"].CellHtmlAttributes = "style='background-color:yellow'";

		for (int i = 0; i < AxpDataGrid1.CurrentDataView.Count; i++)
		{
			DataRow row = AxpDataGrid1.CurrentDataView[i].Row;
			if (AxpDataGrid1.CurrentDataView.Table.Columns.Contains("QuantityPerUnit"))
				row["QuantityPerUnit"] = row["QuantityPerUnit"].ToString().Replace("boxes", "<b style='background-color:yellow'>boxes</b>");
		}
	}
}
