using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample26 : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];
		AxpDataGrid1.UseDataBinding = true;
		if (!Page.IsPostBack)
			ViewState["IdList"] = "";
	}

	private void FillLabelList()
	{
		foreach (string item in Page.Request.Form)
		{
			if (item.Length > "AxpDataGrid1Chk".Length && item.Substring(0, "AxpDataGrid1Chk".Length) == "AxpDataGrid1Chk")
			{
				string[] a = item.Split("_".ToCharArray());
				string MyId = a[1];
				if (!IsInIdList(MyId))
				{
					AddToIdList(MyId);
					Label1.Text = Label1.Text + MyId + "<br>";
				}
			}
		}
	}

	protected void ButtonStore_Click(object sender, EventArgs e)
	{
		FillLabelList();
	}

	protected void ButtonClear_Click(object sender, EventArgs e)
	{
		Label1.Text = "";
		ViewState["IdList"] = "";
	}

	private bool IsInIdList(string myId)
	{
		string s = ViewState["IdList"].ToString();
		int n = s.IndexOf(myId + ",");
		return (n >= 0);
	}

	private void AddToIdList(string myId)
	{
		ViewState["IdList"] = ViewState["IdList"].ToString() + myId + ",";
	}

	private void SetGridCheckBoxes()
	{
		AxpDataGrid1.DataBind();
		for (int i = 0; i < AxpDataGrid1.CurrentDataView.Count; i++)
		{
			DataRow row = AxpDataGrid1.CurrentDataView[i].Row;
			if (IsInIdList(row["ProductId"].ToString()))
				row["ClickMe"] = string.Format("<input type='checkbox' checked name='AxpDataGrid1Chk_{0}'>", row["ProductId"].ToString());
			else
				row["ClickMe"] = string.Format("<input type='checkbox' name='AxpDataGrid1Chk_{0}'>", row["ProductId"].ToString());
		}
	}

	protected void Page_PreRender(object sender, EventArgs e)
	{
		SetGridCheckBoxes();
	}
}
