using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample29 : System.Web.UI.Page
{
	private string baseSql = "SELECT P.ProductId, C.CategoryName, P.ProductName, S.CompanyName"
		+ " FROM Products P, Categories C, Suppliers S WHERE P.CategoryID=C.CategoryID AND P.SupplierID=S.SupplierID";

	/// <summary>
	/// Store the select Filter value in View state so we can check if it has changed 
	/// between page postbacks. If it does change, the grid needs to clear it's state.
	/// </summary>
	private string Filter1Value
	{
		get { object o = ViewState["Filter1Value"]; return ((o == null) ? string.Empty : (string)o); }
		set { ViewState["Filter1Value"] = value; }
	}
	private string Filter2Value
	{
		get { object o = ViewState["Filter2Value"]; return ((o == null) ? string.Empty : (string)o); }
		set { ViewState["Filter2Value"] = value; }
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

		// Set UseDataBinding=true since we are using manual DataBinding.
		AxpDataGrid1.UseDataBinding = true;

		AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", true);
		AxpDataGrid1.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", false);

		if (!Page.IsPostBack)
		{
			// Fill the categories filter with values from the database:
			FillCategoriesLinkSelector();

			// Set the initial ViewState FilterValue:
			Filter1Value = LinkSelector1.SelectedItem;
			Filter2Value = LinkSelector2.SelectedItem;
		}
	}

	private void FillCategoriesLinkSelector()
	{
		System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter("Select CategoryID,CategoryName From Categories", ConfigurationManager.AppSettings["ConnectionString"]);
		DataTable dt = new DataTable();
		da.Fill(dt);
		foreach (DataRow row in dt.Rows)
		{
			Axezz.WebGadgets.LinkItem li = new Axezz.WebGadgets.LinkItem(row["CategoryID"].ToString());
			li.Text = row["CategoryName"].ToString();
			LinkSelector2.LinkItems.Add(li);
		}
		LinkSelector2.LinkItems.Add(new Axezz.WebGadgets.LinkItem("All"));
	}

	protected void Page_PreRender(object sender, EventArgs e)
	{
		// If filter change, Clear AxpDataGrid State
		if (LinkSelector1.SelectedItem != Filter1Value || LinkSelector2.SelectedItem != Filter2Value)
		{
			AxpDataGrid1.ClearState = true;
			AxpDataGrid1.CurrentMode = "grid";
		}

		// Store currently selected value in ViewState so we can check it on next page postback
		Filter1Value = LinkSelector1.SelectedItem;
		Filter2Value = LinkSelector2.SelectedItem;

		// Set AxpDataGrid SQL
		string sqlFilter = string.Empty;
		if (Filter1Value != "All" && Filter1Value.Length == 1) // Length check to avoid invalid sql or inejection attacks
			sqlFilter += " AND P.ProductName LIKE '" + Filter1Value + "%'";
		if (Filter2Value != "All")
			sqlFilter += " AND P.CategoryID =" + Filter2Value;

		AxpDataGrid1.SQL = baseSql + sqlFilter;
		AxpDataGrid1.DataBind();
	}
}
