using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Sample29b : System.Web.UI.Page
{
	private string baseSql = "SELECT * FROM Products";

	/// <summary>
	/// Store the select Filter value in View state so we can check if it has changed 
	/// between page postbacks. If it does change, the grid needs to clear it's state.
	/// </summary>
	private string Filter1Value
	{
		get { object o = ViewState["Filter1Value"]; return ((o == null) ? string.Empty : (string)o); }
		set { ViewState["Filter1Value"] = value; }
	}

  protected void Page_Load(object sender, EventArgs e)
  {
		AxpDataGrid1.ConnectionString = ConfigurationManager.AppSettings["ConnectionString"];

		// Set UseDataBinding=true since we are using manual DataBinding.
		AxpDataGrid1.UseDataBinding = true;

		if (!Page.IsPostBack)
		{
			// Set the initial ViewState FilterValue:
			Filter1Value = LinkSelector1.SelectedItem;
		}
  }

	protected void Page_PreRender(object sender, EventArgs e)
	{
		// If filter change, Clear AxpDataGrid State
		if (LinkSelector1.SelectedItem != Filter1Value)
			AxpDataGrid1.ClearState = true;

		// Store currently selected value in ViewState so we can check it on next page postback
		Filter1Value = LinkSelector1.SelectedItem;

		// Set AxpDataGrid SQL
		string sqlFilter = string.Empty;
		if (Filter1Value != "All" && Filter1Value.Length == 1) // Length check to avoid invalid sql or injection attacks
			sqlFilter += " WHERE ProductName LIKE '" + Filter1Value + "%'";

		AxpDataGrid1.SQL = baseSql + sqlFilter;
		AxpDataGrid1.DataBind();
	}

}
