namespace AxpDBNetCSSample.Samples
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	// ///////////////////////////////////////////////////////////
	// This UserControl can be used with any AxpDataGrid instance. 
	// Follow the code pattern found in Sample31.
	// ///////////////////////////////////////////////////////////

	/// <summary>
	///		Summary description for PagerLinkSelector.
	/// </summary>
	public class PagerLinkSelector : System.Web.UI.UserControl
	{
		protected Axezz.WebGadgets.LinkSelector LinkSelector1;

		// Public Fields

		public int RecordCount = 0;	// Set by Control Owner
		public int NumberOfPages = 0; // Set by Control Owner
		public int PageLinksPerSection = 5;	// Default value for Max Number of Visible Page Links at a time.
		public Axezz.WebControls.AxpDataGrid ConnectedGrid;	// AxpDataGrid connected to this pager

		// Private Fields

		private string previousPageText = "";
		private string previousPageToolTip = "Previous Page";

		private string nextPageText = "";
		private string nextPageToolTip = "Next Page";

		private string firstPageText = "First";
		private string firstPageToolTip = "First Page";

		private string lastPageText = "Last";
		private string lastPageToolTip = "Last Page";

		private int fromPageLink;
		private int toPageLink;


		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.LinkSelector1.Click += new System.EventHandler(this.LinkSelector1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		public void FillPager()
		{
			InitializePager();
			SetPagerItems();
			LinkSelector1.SelectedItem = (ConnectedGrid.CurrentPageIndex + 1).ToString();
		}

		private void InitializePager()
		{
			// Establish from - to page links
			fromPageLink = ((ConnectedGrid.CurrentPageIndex / PageLinksPerSection) * PageLinksPerSection) + 1;
			toPageLink = fromPageLink + PageLinksPerSection - 1;

			if (toPageLink > NumberOfPages)
				toPageLink = NumberOfPages;
			// Disable pager when grid is in Edit mode (not needed, but probably more user friendly)
			LinkSelector1.Enabled = (ConnectedGrid.CurrentMode != "formedit");
		}

		private void SetPagerItems()
		{
			// Set LinkSelector Items

			// Clear and fill the items on each postback.
			LinkSelector1.LinkItems.Clear();

			// Only fill LinkSelector if number of pages is > 1 as it does not make much sense 
			// to have 0 or 1 page items in the pager.
			if (NumberOfPages > 1)
			{
				// First page
				Axezz.WebGadgets.LinkItem liFirst = new Axezz.WebGadgets.LinkItem(firstPageText);
				liFirst.ToolTip = firstPageToolTip;
				LinkSelector1.LinkItems.Add(liFirst);

				// Previous page
				Axezz.WebGadgets.LinkItem liPrevious = new Axezz.WebGadgets.LinkItem(previousPageText);
				liPrevious.ToolTip = previousPageToolTip;
				liPrevious.Enabled = (ConnectedGrid.CurrentPageIndex > 0);
				LinkSelector1.LinkItems.Add(liPrevious);

				// Page number links
				for (int i = fromPageLink; i<=toPageLink; i++)
					LinkSelector1.LinkItems.Add(new Axezz.WebGadgets.LinkItem(i.ToString()));

				// Next page
				Axezz.WebGadgets.LinkItem liNext = new Axezz.WebGadgets.LinkItem(nextPageText);
				liNext.ToolTip = nextPageToolTip;
				liNext.Enabled = (ConnectedGrid.CurrentPageIndex < (NumberOfPages) - 1);
				LinkSelector1.LinkItems.Add(liNext);

				// Last page
				Axezz.WebGadgets.LinkItem liLast = new Axezz.WebGadgets.LinkItem(lastPageText);
				liLast.ToolTip = lastPageToolTip;
				LinkSelector1.LinkItems.Add(liLast);
			}
		}

		private void LinkSelector1_Click(object sender, System.EventArgs e)
		{		
			if (LinkSelector1.SelectedItem == firstPageText)
				ConnectedGrid.CurrentPageIndex = 0;
			else if (LinkSelector1.SelectedItem == previousPageText)
				ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex - 1;
			else if (LinkSelector1.SelectedItem == nextPageText)
				ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex + 1;
			else if (LinkSelector1.SelectedItem == lastPageText)
				ConnectedGrid.CurrentPageIndex = NumberOfPages - 1;
			else
				ConnectedGrid.CurrentPageIndex = int.Parse(LinkSelector1.SelectedItem) - 1;
		}

	}
}
