using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	public class Sample16 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox ProductName;
		protected System.Web.UI.WebControls.TextBox SupplierID;
		protected Button Search;
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;

		private string PreviousWhereClause
		{
			get { object o = ViewState["PreviousWhereClause"]; return((o == null) ? string.Empty : (string)o); }
			set { ViewState["PreviousWhereClause"] = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			// Because WebControls are loaded after the grid, we set the grid property .UseDataBinding = True.
			// We must then call the grid DataBind method after setting other properties.
			// For simplicity in this example we do all the work in the Page PreRender event
			AxpDataGrid1.UseDataBinding = true;
		}

		private void InitGrid()
		{
			string sql = "Select * From Products";
			string whereClause = string.Empty;
			string productNameFilter = ProductName.Text.Trim().Replace("'", "''");
			if (productNameFilter.Length > 0 )
				whereClause = string.Format (" Where ProductName Like '{0}%'", productNameFilter);
		
			if (SupplierID.Text.Trim() != string.Empty)
			{
				if (whereClause.Length == 0)
					whereClause = " Where";
				else
					whereClause = whereClause + " And";
				int supId = -1;
				try
				{
					supId = int.Parse(SupplierID.Text);
				}
				catch {}
				whereClause = whereClause + " SupplierID=" + supId.ToString();
			}
			sql = sql + whereClause;
			AxpDataGrid1.SQL = sql;
			if (PreviousWhereClause != sql)
				// We keep the previous sql in a ViewState variable and resets the AxpDataGrid "state" if the SQL has changed.
				AxpDataGrid1.ClearState = true;		
			PreviousWhereClause = sql;

			AxpDataGrid1.DataBind();
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			InitGrid();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);
		}
		#endregion
	}
}
