using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample26.
	/// </summary>
	public class Sample26 : System.Web.UI.Page
	{
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Button ButtonStore;
		protected System.Web.UI.WebControls.Button ButtonClear;

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			AxpDataGrid1.UseDataBinding = true;
			if (!Page.IsPostBack)
				ViewState["IdList"] = "";
		}

		private void FillLabelList()
		{
			foreach (string item in Page.Request.Form)
			{
				if (item.Length > "AxpDataGrid1Chk".Length && item.Substring(0, "AxpDataGrid1Chk".Length) == "AxpDataGrid1Chk")
				{
					string[] a = item.Split("_".ToCharArray());
					string MyId  = a[1];
					if (!IsInIdList(MyId))
					{
						AddToIdList(MyId);
						Label1.Text = Label1.Text + MyId + "<br>";
					}
				}
			}
		}

		private void ButtonStore_Click(object sender, System.EventArgs e)
		{
			FillLabelList();		
		}

		private void ButtonClear_Click(object sender, System.EventArgs e)
		{
			Label1.Text = "";
			ViewState["IdList"] = "";
		}

		private bool IsInIdList(string myId)
		{
			string s = ViewState["IdList"].ToString();
			int n = s.IndexOf(myId + ",");
			return (n >= 0);
		}

		private void AddToIdList(string myId)
		{
			ViewState["IdList"] = ViewState["IdList"].ToString() + myId + ",";
		}

		private void SetGridCheckBoxes()
		{
			AxpDataGrid1.DataBind();
			for (int i=0;i<AxpDataGrid1.CurrentDataView.Count;i++)
			{
				DataRow row = AxpDataGrid1.CurrentDataView[i].Row;
				if (IsInIdList(row["ProductId"].ToString()))
					row["ClickMe"] = string.Format("<input type='checkbox' checked name='AxpDataGrid1Chk_{0}'>", row["ProductId"].ToString());
				else
					row["ClickMe"] = string.Format("<input type='checkbox' name='AxpDataGrid1Chk_{0}'>", row["ProductId"].ToString());			
			}
		}

		private void Sample26_PreRender(object sender, System.EventArgs e)
		{
			SetGridCheckBoxes();		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.ButtonStore.Click += new System.EventHandler(this.ButtonStore_Click);
			this.ButtonClear.Click += new System.EventHandler(this.ButtonClear_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Sample26_PreRender);

		}
		#endregion


	}
}
