using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample29b.
	/// </summary>
	public class Sample29b : System.Web.UI.Page
	{
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;
		protected Axezz.WebGadgets.LinkSelector LinkSelector1;

		private string baseSql = "SELECT * FROM Products";

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);
		}
		#endregion

		/// <summary>
		/// Store the select Filter value in View state so we can check if it has changed 
		/// between page postbacks. If it does change, the grid needs to clear it's state.
		/// </summary>
		private string Filter1Value
		{
			get { object o = ViewState["Filter1Value"]; return((o == null) ? string.Empty : (string)o); }
			set { ViewState["Filter1Value"] = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];

			// Set UseDataBinding=true since we are using manual DataBinding.
			AxpDataGrid1.UseDataBinding = true;
			
			if (!Page.IsPostBack)
			{
				// Set the initial ViewState FilterValue:
				Filter1Value = LinkSelector1.SelectedItem;
			}
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			// If filter change, Clear AxpDataGrid State
			if (LinkSelector1.SelectedItem != Filter1Value)
				AxpDataGrid1.ClearState = true;

			// Store currently selected value in ViewState so we can check it on next page postback
			Filter1Value = LinkSelector1.SelectedItem;

			// Set AxpDataGrid SQL
			string sqlFilter = string.Empty;
			if (Filter1Value != "All" && Filter1Value.Length == 1) // Length check to avoid invalid sql or injection attacks
				sqlFilter += " WHERE ProductName LIKE '" + Filter1Value + "%'";

			AxpDataGrid1.SQL = baseSql + sqlFilter;
			AxpDataGrid1.DataBind();
		}

	}
}
