using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;
using System.Data.OleDb;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample31.
	/// </summary>
	public class Sample31 : System.Web.UI.Page
	{
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;
		protected PagerLinkSelector Pager1;
		protected PagerLinkSelector Pager2;

		private int recordCount = 0;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Standard Demo edit settings

			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", true);
			AxpDataGrid1.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", false);

			// Setting Productname to a required field since the grid is unable to detect it on some Access databases
			Axezz.WebControls.EditFieldItem efi = new Axezz.WebControls.EditFieldItem();
			efi.ColumnName = "ProductName";
			efi.Required = true;
			AxpDataGrid1.SetEditField(efi);

			// This sample requires Manual databinding
			AxpDataGrid1.UseDataBinding = true;

			// Set some RecordsPerPageOptions that makes sense for testing on unlicensed versions of the grid
			AxpDataGrid1.RecordsPerPageOptions = "2,3,4,5,7,10,15,20,30";

			InitPaging();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AxpDataGrid1.Load += new System.EventHandler(this.AxpDataGrid1_Load);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private void InitPaging()
		{
			// Count records in recordset
			recordCount = GetRecordCount("SELECT COUNT(*) FROM Products");

			// Set grid RecordCount property. The grid will then not have to count records and we save some computing/db time
			AxpDataGrid1.RecordCount = recordCount;

			// Set related Pager properties

			// ********************************************************************
			//  Set record count=30 due to unlicensed AxpDataGrid in sample!
			recordCount = 30;		//  Remove this line if you have a licensed copy!
			//  ********************************************************************

			Pager1.ConnectedGrid = AxpDataGrid1;
			Pager1.RecordCount = recordCount;

			Pager2.ConnectedGrid = AxpDataGrid1;
			Pager2.RecordCount = recordCount;
		}

		private int GetRecordCount(string cmdText)
		{			
			int result = 0;
			OleDbConnection connection = new OleDbConnection(ConfigurationSettings.AppSettings["ConnectionString"]);
			OleDbCommand cmd = new OleDbCommand(cmdText, connection);
			connection.Open();
			OleDbDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
			if (reader.Read())
				result = int.Parse(reader[0].ToString());			
			reader.Close();			
			return result;
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			AxpDataGrid1.DataBind();
			Pager1.FillPager();
			Pager2.FillPager();	
		}

		private void AxpDataGrid1_Load(object sender, System.EventArgs e)
		{
			// Calculate number of pages in grid load as the grid's PageSize is available here (the user might have changed it in the user interface)
			Pager1.NumberOfPages = recordCount / AxpDataGrid1.PageSize;
			Pager2.NumberOfPages = recordCount / AxpDataGrid1.PageSize;		
		}
	}
}
