using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample8b.
	/// </summary>
	public class Sample8b : System.Web.UI.Page
	{
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid2;

		private string ProductId
		{
			get { object o = ViewState["ProductId"]; return((o == null) ? string.Empty : (string)o); }
			set { ViewState["ProductId"] = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			AxpDataGrid2.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			AxpDataGrid2.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", false);
			AxpDataGrid2.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", false);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AxpDataGrid1.SelectRowClick += new System.EventHandler(this.AxpDataGrid1_SelectRowClick);
			this.AxpDataGrid2.UpdateClick += new System.EventHandler(this.AxpDataGrid2_UpdateClick);
			this.AxpDataGrid2.DeleteClick += new System.EventHandler(this.AxpDataGrid2_DeleteClick);
			this.AxpDataGrid2.InsertClick += new System.EventHandler(this.AxpDataGrid2_InsertClick);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private bool _rowClicked = false;
		private void AxpDataGrid1_SelectRowClick(object sender, System.EventArgs e)
		{
			ProductId = ((Axezz.WebControls.RowClickEventArgs) e).PrimaryKeyValues;
			AxpDataGrid2.ClearState = true;
			_rowClicked = true;
		}

		private void Grid2DataBind()
		{
			if (ProductId.Length > 0)
				AxpDataGrid2.SQL = String.Format("Select * From Products Where ProductId={0}", ProductId);
			else
				AxpDataGrid2.SQL = "Select * From Products";			
			if (_rowClicked) // make sure we are always in edit mode when a row is selected
				AxpDataGrid2.CurrentMode = "formedit";			
			AxpDataGrid2.DataBind();
		}

		private void RefreshGrid1()
		{
			AxpDataGrid1.UseDataBinding = true;
			AxpDataGrid1.AxConnection.Connection.Close();
			AxpDataGrid1.AxConnection.Connection.Open();
			AxpDataGrid1.RecordCount = -1;		// force a recount 
			AxpDataGrid1.DataBind();
			AxpDataGrid1.UseDataBinding = false;
		}
	
		private void Page_PreRender(object sender, System.EventArgs e)
		{
			Grid2DataBind();
			if (_grid1MustBeRefreshed)
				RefreshGrid1();
		}

		private bool _grid1MustBeRefreshed  = false;
		private void AxpDataGrid2_InsertClick(object sender, System.EventArgs e)
		{
			_grid1MustBeRefreshed = true;
			AxpDataGrid1.ClearState = true;
		}

		private void AxpDataGrid2_UpdateClick(object sender, System.EventArgs e)
		{
			_grid1MustBeRefreshed = true;
		}

		private void AxpDataGrid2_DeleteClick(object sender, System.EventArgs e)
		{
			_grid1MustBeRefreshed = true;
			AxpDataGrid1.ClearState = true;		
		}

	}
}
