using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample9b.
	/// </summary>
	public class Sample9b : System.Web.UI.Page
	{

		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid2;

		private string CustomerId
		{
			get { object o = ViewState["CustomerId"]; return((o == null) ? string.Empty : (string)o); }
			set { ViewState["CustomerId"] = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			AxpDataGrid2.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];
			if (AxpDataGrid2.AxConnection.DatabaseEngine == "ACCESS")
				AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName & ' ' & LastName", "2", true);
			else
				AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName + ' ' + LastName", "2", true);
			
			AxpDataGrid2.AddEditLookup("ShipVia", "Shippers", "ShipperID", "CompanyName", "2", true);
		}

		private bool _rowClicked = false;
		private void AxpDataGrid1_SelectRowClick(object sender, System.EventArgs e)
		{
			CustomerId = ((Axezz.WebControls.RowClickEventArgs) e).PrimaryKeyValues;
			AxpDataGrid2.ClearState = true;
			_rowClicked = true;
		}

		private void Grid2DataBind()
		{
			// For Insert purposes, set the CustomerId default value 
			Axezz.WebControls.EditFieldItem editCustomerIdField = new Axezz.WebControls.EditFieldItem();
			editCustomerIdField.ColumnName = "CustomerId";
			editCustomerIdField.DefaultValue = CustomerId;
			AxpDataGrid2.SetEditField(editCustomerIdField);

			// Construct Sql for grid 2
			string sql = "Select OrderId, CustomerId, OrderDate, RequiredDate, ShippedDate, Freight FROM Orders";
			if (CustomerId != String.Empty)
				sql = sql + " WHERE CustomerId='" + CustomerId + "'";
			else
				sql = sql + " WHERE 1=2" ; // ensures that we get an empty recordset 
		
			AxpDataGrid2.SQL = sql;

			if (_rowClicked) // make sure we are always in grid mode when a row is selected
				AxpDataGrid2.CurrentMode = "grid";
		
			AxpDataGrid2.DataBind();
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			Grid2DataBind();		
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AxpDataGrid1.SelectRowClick += new System.EventHandler(this.AxpDataGrid1_SelectRowClick);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

	}
}
