Imports System.Configuration.ConfigurationManager

Partial Class Sample08b
	Inherits System.Web.UI.Page

	Private Property ProductId() As String
		Get
			Dim o As Object = ViewState("ProductId")
			If o Is Nothing Then
				Return String.Empty
			Else
				Return CStr(o)
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("ProductId") = Value
		End Set
	End Property

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		AxpDataGrid2.ConnectionString = AppSettings("ConnectionString")
		AxpDataGrid2.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", True)
		AxpDataGrid2.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", False)
	End Sub

	Private _rowClicked As Boolean = False
	Private Sub AxpDataGrid1_SelectRowClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid1.SelectRowClick
		ProductId = CType(e, Axezz.WebControls.RowClickEventArgs).PrimaryKeyValues
		AxpDataGrid2.ClearState = True
		_rowClicked = True
	End Sub

	Private Sub Grid2DataBind()
		If ProductId.Length > 0 Then
			AxpDataGrid2.SQL = String.Format("Select * From Products Where ProductId={0}", ProductId)
		Else
			AxpDataGrid2.SQL = "Select * From Products"
		End If
		If _rowClicked Then		' make sure we are always in edit mode when a row is selected
			AxpDataGrid2.CurrentMode = "formedit"
		End If
		AxpDataGrid2.DataBind()
	End Sub

	Private Sub RefreshGrid1()
		AxpDataGrid1.UseDataBinding = True
		AxpDataGrid1.AxConnection.Connection.Close()
		AxpDataGrid1.AxConnection.Connection.Open()
		AxpDataGrid1.RecordCount = -1		' force a recount 
		AxpDataGrid1.DataBind()
		AxpDataGrid1.UseDataBinding = False
	End Sub

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
		Grid2DataBind()
		If _grid1MustBeRefreshed Then
			RefreshGrid1()
		End If
	End Sub

	Private _grid1MustBeRefreshed As Boolean = False
	Private Sub AxpDataGrid2_InsertClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid2.InsertClick
		_grid1MustBeRefreshed = True
		AxpDataGrid1.ClearState = True
	End Sub

	Private Sub AxpDataGrid2_UpdateClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid2.UpdateClick
		_grid1MustBeRefreshed = True
	End Sub

	Private Sub AxpDataGrid2_DeleteClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid2.DeleteClick
		_grid1MustBeRefreshed = True
		AxpDataGrid1.ClearState = True
	End Sub

End Class
