Imports System.Configuration.ConfigurationManager

Partial Class Sample09
	Inherits System.Web.UI.Page

	Protected CustomerId As String = ""

	Private Property PrevCustId() As String
		Get
			If Not ViewState("PrevCustId") Is Nothing Then
				Return ViewState("PrevCustId").ToString()
			Else
				Return ""
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("PrevCustId") = Value
		End Set
	End Property

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		' We are setting all properties in code-behind in this case. 
		' Not absolutely required, but might be clearer instead of
		' spreading property settings between aspx and code-behind.

		' AxpDataGrid1 (The Customer grid)

		AxpDataGrid1.SQL = "SELECT CustomerId,CompanyName FROM Customers"
		AxpDataGrid1.GridCellWidths = "0,160"
		AxpDataGrid1.DisplayType = "grid"
		AxpDataGrid1.DisplayNavBar = "top"
		AxpDataGrid1.GridDisplayIndex = False
		AxpDataGrid1.GridFieldsShow = "2"
		AxpDataGrid1.OrderByFields = "2"
		AxpDataGrid1.GridColsNoSort = "*"
		AxpDataGrid1.SetGridFreeFormatCellByCol(2, "<a class=""AXDBTable"" href="""" onclick=""return(setLinkField('#CustomerId#'))"">#CompanyName#</a>")
	End Sub

	Protected Sub AxpDataGrid1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid1.Load
		' AxpDataGrid2 (Orders Grid and Edit form)

		' on initial page display we fetch the current CustomerId from the master grid to the detail grid
		' from the first row of the grid : AxpDataGrid1.CurrentDataView(0)("CustomerId")
		If CustomerId = String.Empty Then
			If AxpDataGrid1.CurrentDataView.Count > 0 Then
				CustomerId = CStr(AxpDataGrid1.CurrentDataView(0)("CustomerId"))
			End If
		End If

		AxpDataGrid2.ConnectionString = AppSettings("ConnectionString")

		' We keep track of the prev CustomerId used so we can clear the state of the detail grid when CustomerId change
		' Not strictly needed but nice to have...
		If Not Request("CustomerId") Is Nothing Then
			CustomerId = Request("CustomerId")
			If CustomerId <> PrevCustId Then
				If PrevCustId <> "" Then
					AxpDataGrid2.ClearState = True
				End If
				PrevCustId = CustomerId
			End If
		End If

		' Construct SQL
		Dim sql As String = "Select OrderId, CustomerId, OrderDate, RequiredDate, ShippedDate, Freight FROM Orders"
		If CustomerId <> String.Empty Then
			sql = sql + " WHERE CustomerId='" + CustomerId + "'"
		Else
			sql = sql + " WHERE 1=2"			' ensures that we get an empty recordset 
		End If
		AxpDataGrid2.SQL = sql

		' For Insert purposes, set the CustomerId default value 
		Dim editCustomerIdField As New Axezz.WebControls.EditFieldItem
		With editCustomerIdField
			.ColumnName = "CustomerId"
			.DefaultValue = CustomerId
		End With
		AxpDataGrid2.SetEditField(editCustomerIdField)

		' Then set more standard properties
		AxpDataGrid2.GridFieldsHide = "1"
		AxpDataGrid2.EditSQL = "Select * FROM Orders"		 ' Always simplify the table Edit Sql to "select * from tablename"
		AxpDataGrid2.DeleteSQL = "Delete From Orders"		 ' Required if Delete is enabled
		AxpDataGrid2.EditOptions = "ALL NOVIEW"
		AxpDataGrid2.EditNewPKStatement = "autoincrement"
		AxpDataGrid2.DisplayExcelIcon = False
		AxpDataGrid2.EditPrimaryKeys = "OrderID"
		AxpDataGrid2.FormFieldsHide = "1,2"
		AxpDataGrid2.FormCellWidths = "100,400"
		AxpDataGrid2.EditFieldsReadOnly = "1,2"
		AxpDataGrid2.DisplayNavBar = "both"
		AxpDataGrid2.DisplayRecordsPerPageSelect = True
		AxpDataGrid2.RowRollOverEffect = True
		AxpDataGrid2.RowClickAction = "openform"
		AxpDataGrid2.GridDisplayIndex = False
		If AxpDataGrid2.AxConnection.DatabaseEngine = "ACCESS" Then
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName & ' ' & LastName", "2", True)
		Else
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName + ' ' + LastName", "2", True)
		End If
		AxpDataGrid2.AddEditLookup("ShipVia", "Shippers", "ShipperID", "CompanyName", "2", True)

	End Sub
End Class
