Imports System.Configuration.ConfigurationManager

Partial Class Sample09b
	Inherits System.Web.UI.Page

	Private Property CustomerId() As String
		Get
			Dim o As Object = ViewState("CustomerId")
			If o Is Nothing Then
				Return String.Empty
			Else
				Return CStr(o)
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("CustomerId") = Value
		End Set
	End Property

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		AxpDataGrid2.ConnectionString = AppSettings("ConnectionString")

		If AxpDataGrid2.AxConnection.DatabaseEngine = "ACCESS" Then
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName & ' ' & LastName", "2", True)
		Else
			AxpDataGrid2.AddEditLookup("EmployeeId", "Employees", "EmployeeId", "FirstName + ' ' + LastName", "2", True)
		End If
		AxpDataGrid2.AddEditLookup("ShipVia", "Shippers", "ShipperID", "CompanyName", "2", True)
	End Sub

	Private _rowClicked As Boolean = False
	Private Sub AxpDataGrid1_SelectRowClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid1.SelectRowClick
		CustomerId = CType(e, Axezz.WebControls.RowClickEventArgs).PrimaryKeyValues
		AxpDataGrid2.ClearState = True
		_rowClicked = True
	End Sub

	Private Sub Grid2DataBind()
		' For Insert purposes, set the CustomerId default value 
		Dim editCustomerIdField As New Axezz.WebControls.EditFieldItem
		With editCustomerIdField
			.ColumnName = "CustomerId"
			.DefaultValue = CustomerId
		End With
		AxpDataGrid2.SetEditField(editCustomerIdField)

		' Construct Sql for grid 2
		Dim sql As String = "Select OrderId, CustomerId, OrderDate, RequiredDate, ShippedDate, Freight FROM Orders"
		If CustomerId <> String.Empty Then
			sql = sql + " WHERE CustomerId='" + CustomerId + "'"
		Else
			sql = sql + " WHERE 1=2"			' ensures that we get an empty recordset 
		End If
		AxpDataGrid2.SQL = sql

		If _rowClicked Then		' make sure we are always in grid mode when a row is selected
			AxpDataGrid2.CurrentMode = "grid"
		End If
		AxpDataGrid2.DataBind()
	End Sub

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
		Grid2DataBind()
	End Sub


End Class
