Imports System.Configuration.ConfigurationManager

Partial Class Sample16
	Inherits System.Web.UI.Page

	Private Property PreviousWhereClause() As String
		Get
			Dim o As Object = ViewState("PreviousWhereClause")
			If o Is Nothing Then
				Return String.Empty
			Else
				Return CStr(o)
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("PreviousWhereClause") = Value
		End Set
	End Property

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		' Because WebControls are loaded after the grid, we set the grid property .UseDataBinding = True.
		' We must then call the grid DataBind method after setting other properties.
		' For simplicity in this example we do all the work in the Page PreRender event
		AxpDataGrid1.UseDataBinding = True
	End Sub

	Private Sub InitGrid()
		Dim sql As String = "Select * From Products"
		Dim whereClause As String = String.Empty
		If Trim(ProductName.Text) <> String.Empty Then
			whereClause = " Where ProductName Like '" + Trim(ProductName.Text).Replace("'", "''") + "%'"
		End If
		If Trim(SupplierID.Text) <> String.Empty Then
			Dim intSupplierId As Integer
			If Integer.TryParse(SupplierID.Text, intSupplierId) Then
				If whereClause.Length = 0 Then
					whereClause = " Where"
				Else
					whereClause = whereClause + " And"
				End If
				whereClause = whereClause + " SupplierID=" + intSupplierId.ToString()
			End If
		End If
		sql = sql + whereClause
		AxpDataGrid1.SQL = sql

		If PreviousWhereClause <> sql Then
			' We keep the previous sql in a ViewState variable and resets the AxpDataGrid "state" if the SQL has changed.
			AxpDataGrid1.ClearState = True
		End If
		PreviousWhereClause = sql
	End Sub

	Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
		InitGrid()
		AxpDataGrid1.DataBind()	 ' Must be called when .UseDataBinding = True
	End Sub
End Class
