Imports System.Configuration.ConfigurationManager

Partial Class Sample26
	Inherits System.Web.UI.Page

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		AxpDataGrid1.UseDataBinding = True
		If Not Page.IsPostBack Then
			ViewState("IdList") = ""
		End If
	End Sub

	' Fill the Label with the list of ProductId's checked on the current page
	' In a real world application, you would replace this code with the action to be taken on rows that are checked.
	Private Sub FillLabelList()
		For Each item As String In Page.Request.Form
			If Left(item, "AxpDataGrid1Chk".Length) = "AxpDataGrid1Chk" Then
				Dim a() As String = Split(item, "_")
				Dim MyId As String = a(1)
				If Not IsInIdList(MyId) Then
					AddToIdList(MyId)
					Label1.Text = Label1.Text + MyId + "<br>"
				End If
			End If
		Next
	End Sub

	Private Sub ButtonStore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStore.Click
		FillLabelList()
	End Sub

	Private Sub ButtonClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonClear.Click
		Label1.Text = ""
		ViewState("IdList") = ""
	End Sub

	Private Function IsInIdList(ByVal MyId As String) As Boolean
		Return (ViewState("IdList").ToString().IndexOf(MyId + ",") >= 0)
	End Function

	Private Sub AddToIdList(ByVal MyId As String)
		ViewState("IdList") = ViewState("IdList").ToString() + MyId + ","
	End Sub

	Private Sub SetGridCheckBoxes()
		AxpDataGrid1.DataBind()
		For i As Integer = 0 To AxpDataGrid1.CurrentDataView.Count - 1
			Dim row As DataRow = AxpDataGrid1.CurrentDataView(i).Row
			If IsInIdList(row("ProductId").ToString) Then
				row("ClickMe") = String.Format("<input type='checkbox' checked name='AxpDataGrid1Chk_{0}'>", row("ProductId").ToString)
			Else
				row("ClickMe") = String.Format("<input type='checkbox' name='AxpDataGrid1Chk_{0}'>", row("ProductId").ToString)
			End If
		Next
	End Sub

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
		SetGridCheckBoxes()
	End Sub

End Class
