Imports System.Configuration.ConfigurationManager

Partial Class Sample29
	Inherits System.Web.UI.Page

	Private baseSql As String = "SELECT P.ProductId, C.CategoryName, P.ProductName, S.CompanyName" _
			+ " FROM Products P, Categories C, Suppliers S WHERE P.CategoryID=C.CategoryID AND P.SupplierID=S.SupplierID"

	Private Property Filter1Value() As String
		Get
			Dim o As Object = ViewState("Filter1Value")
			If o Is Nothing Then
				Return String.Empty
			Else
				Return CStr(o)
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("Filter1Value") = Value
		End Set
	End Property

	Private Property Filter2Value() As String
		Get
			Dim o As Object = ViewState("Filter2Value")
			If o Is Nothing Then
				Return String.Empty
			Else
				Return CStr(o)
			End If
		End Get
		Set(ByVal Value As String)
			ViewState("Filter2Value") = Value
		End Set
	End Property

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		' Set UseDataBinding=true since we are using manual DataBinding.
		AxpDataGrid1.UseDataBinding = True

		AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", True)
		AxpDataGrid1.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", False)

		If Not Page.IsPostBack Then
			' Fill the categories filter with values from the database:
			FillCategoriesLinkSelector()

			' Set the initial ViewState FilterValue:
			Filter1Value = LinkSelector1.SelectedItem
			Filter2Value = LinkSelector2.SelectedItem
		End If
	End Sub

	Private Sub FillCategoriesLinkSelector()
		Dim da As System.Data.OleDb.OleDbDataAdapter = New System.Data.OleDb.OleDbDataAdapter("Select CategoryID,CategoryName From Categories", AppSettings("ConnectionString"))
		Dim dt As DataTable = New DataTable
		da.Fill(dt)
		For Each row As DataRow In dt.Rows
			Dim li As Axezz.WebGadgets.LinkItem = New Axezz.WebGadgets.LinkItem(row("CategoryID").ToString())
			li.Text = row("CategoryName").ToString()
			LinkSelector2.LinkItems.Add(li)
		Next
		LinkSelector2.LinkItems.Add(New Axezz.WebGadgets.LinkItem("All"))
	End Sub

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
		' If filter change, Clear AxpDataGrid State
		If (LinkSelector1.SelectedItem <> Filter1Value Or LinkSelector2.SelectedItem <> Filter2Value) Then
			AxpDataGrid1.ClearState = True
			AxpDataGrid1.CurrentMode = "grid"
		End If

		' Store currently selected value in ViewState so we can check it on next page postback
		Filter1Value = LinkSelector1.SelectedItem
		Filter2Value = LinkSelector2.SelectedItem

		' Set AxpDataGrid SQL
		Dim sqlFilter As String = String.Empty
		If (Filter1Value <> "All" And Filter1Value.Length = 1) Then		' Length check to avoid invalid sql or inejection attacks
			sqlFilter += " AND P.ProductName LIKE '" + Filter1Value + "%'"
		End If
		If (Filter2Value <> "All") Then
			sqlFilter += " AND P.CategoryID =" + Filter2Value
		End If
		AxpDataGrid1.SQL = baseSql + sqlFilter
		AxpDataGrid1.DataBind()

	End Sub

End Class
