<%@ Page Language="VB" AutoEventWireup="false" CodeFile="Sample30.aspx.vb" Inherits="Sample30" 
 UICulture="es-ES"
%>
<%@ Register TagPrefix="axp" Namespace="Axezz.WebControls" Assembly="AxpDBNet" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
    <link href="../StyleSheet.css" type="text/css" rel="stylesheet">
    <link href="../css/AxpStyleXPGrid1.css" type="text/css" rel="stylesheet">
</head>
<body>
    <form id="form1" runat="server">
    <div>
		<a href="../Default.aspx"><b>Back to sample index</b></a><br>
		<h3>Sample 30 - Localization Sample</h3>

		<p><i>
			<b>1)</b> Initially, uiCulture="es-ES" has been set in the Page directive (see top of aspx source)<br>
			Remove it to see the default UiCulture.<br>
			See the .net documentation for more information on how the UiCulture can be set
			per machine, application etc.</i>
		</p>
		<p>
			CurrentThread.CurrentUICulture: <%=System.Threading.Thread.CurrentThread.CurrentUICulture.Name%><br>
			CurrentThread.CurrentCulture: <%=System.Threading.Thread.CurrentThread.CurrentCulture.Name%><br>
		</p>
		<p>
			<i>
			<b>2)</b> Clicking on the radio buttons below, will dynamically alter both the current thread's CurrentUiCulture and 
			the CurrentCulture. These languages are supplied in satellite assemblies and can be found
			in sub folders in the bin directory of the application. Note that the localized version
			contain the "root" language</i>
		</p>
		<p>
			<asp:RadioButtonList id="RadioButtonList1" runat="server" RepeatDirection="Horizontal" AutoPostBack="True">
				<asp:ListItem Value="es-ES">Spanish (es-ES)</asp:ListItem>
				<asp:ListItem Value="en-US">English (en-US)</asp:ListItem>
				<asp:ListItem Value="de-DE">German (de-DE)</asp:ListItem>
				<asp:ListItem Value="nl-NL">Dutch (nl-NL)</asp:ListItem>
				<asp:ListItem Value="it-IT">Italian (it-IT)</asp:ListItem>
				<asp:ListItem Value="nb-NO">Norwegian (nb-NO)</asp:ListItem>
			</asp:RadioButtonList>
		</p>
		<p>
			<i><b>3)</b> Strings can be supplied in a <b>resx file</b> for unsupported languages.
			The locale name does not necessarily need to be predefined in .net, but if is,
			use the proper uiCultureName (see <a target="_blank"	href="http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cpref/html/frlrfSystemGlobalizationCultureInfoClassTopic.asp">msdn</a> for a list or
			use Visual Studio)</i>
		</p>
		<p>
			<asp:CheckBox ID="showCatalan" Runat="server" autopostback="True" Text="Display Spanish Catalan"></asp:CheckBox>
		</p>
		<p>
			<i><b>4)</b> Finally you can add items to the AxpDataGrid.UICustomStrings collection to
			set individual strings on a specific AxpDataGrid instance.</i>
		</p>
		<p>
			Fill in a value here to set the RecordsPerPage string:&nbsp;
			<asp:TextBox ID="customText" Runat="server"></asp:TextBox>
			<asp:Button ID="ok" Runat="server" Text="OK"></asp:Button>
		</p>
		<p>
			<Axp:AxpDataGrid id="AxpDataGrid1" runat="server" 
				SQL="Select * From Products"
				DeleteSQL="Delete From Products"
				DisplayNavBar="both"
				EditOptions="ALL"
				EditPrimaryKeys="ProductId"
				EditNewPKStatement="autoincrement"
				RowRollOverEffect="True"
				GridDisplayIndex="False"
				CopyFields="*"				
				PageSize="10"
				RowClickAction="openform"></Axp:AxpDataGrid>
		</p>
		<b> Axezz, Oslo Norway 2003-<%=System.DateTime.Now.Year%></b><br><br>
    
    </div>
    </form>
</body>
</html>
