Imports System.Configuration.ConfigurationManager

Partial Class Sample31
	Inherits System.Web.UI.Page

	Private recordCount As Integer = 0

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		AxpDataGrid1.ConnectionString = AppSettings("ConnectionString")
		' Standard Demo edit settings
		' Setting Productname to a required field since the grid is unable to detect it on some Access databases
		Dim efi As Axezz.WebControls.EditFieldItem = New Axezz.WebControls.EditFieldItem
		efi.ColumnName = "ProductName"
		efi.Required = True
		AxpDataGrid1.SetEditField(efi)

		AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", True)
		AxpDataGrid1.AddEditLookup("CategoryId", "Categories", "CategoryId", "CategoryName", "2", False)


		' This sample requires Manual databinding
		AxpDataGrid1.UseDataBinding = True

		' Set some RecordsPerPageOptions that makes sense for testing on unlicensed versions of the grid
		AxpDataGrid1.RecordsPerPageOptions = "2,3,4,5,7,10,15,20,30"

		InitPaging()
	End Sub

	Private Sub InitPaging()
		' Count records in recordset
		recordCount = GetRecordCount("SELECT COUNT(*) FROM Products")

		' Set grid RecordCount property. The grid will then not have to count records and we save some computing/db time
		AxpDataGrid1.RecordCount = recordCount

		' Set related Pager properties

		' ********************************************************************
		' Set record count=30 due to unlicensed AxpDataGrid in sample!
		recordCount = 30		' Remove this line if you have a licensed copy!
		' ********************************************************************

		Pager1.ConnectedGrid = AxpDataGrid1
		Pager1.RecordCount = recordCount

		Pager2.ConnectedGrid = AxpDataGrid1
		Pager2.RecordCount = recordCount
	End Sub

	Private Function GetRecordCount(ByVal cmdText As String) As Integer
		Dim result As Integer = 0
		Dim connection As New OleDb.OleDbConnection(AppSettings("ConnectionString"))
		Dim cmd As New OleDb.OleDbCommand(cmdText, connection)
		connection.Open()
		Dim reader As OleDb.OleDbDataReader = cmd.ExecuteReader(CommandBehavior.CloseConnection)
		If reader.Read Then
			result = Integer.Parse(reader(0).ToString())
		End If
		reader.Close()
		Return result
	End Function

	Private Sub AxpDataGrid1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles AxpDataGrid1.Load
		' Calculate number of pages in grid load as the grid's PageSize is available here (the user might have changed it in the user interface)
		Pager1.NumberOfPages = recordCount \ AxpDataGrid1.PageSize
		Pager2.NumberOfPages = recordCount \ AxpDataGrid1.PageSize
	End Sub

	Private Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
		AxpDataGrid1.DataBind()
		Pager1.FillPager()
		Pager2.FillPager()
	End Sub


End Class
