Public Class PagerLinkSelector
	Inherits System.Web.UI.UserControl

	' ///////////////////////////////////////////////////////////
	' This UserControl can be used with any AxpDataGrid instance. 
	' Follow the code pattern found in Sample31.
	' ///////////////////////////////////////////////////////////

	Protected WithEvents LinkSelector1 As Axezz.WebGadgets.LinkSelector

	' Public Fields

	Public RecordCount As Integer = 0	' Set by Control Owner
	Public NumberOfPages As Integer = 0 ' Set by Control Owner
	Public PageLinksPerSection As Integer = 5	' Default value for Max Number of Visible Page Links at a time.
	Public ConnectedGrid As Axezz.WebControls.AxpDataGrid	' AxpDataGrid connected to this pager

	' Private Fields

	Private previousPageText As String = ""
	Private previousPageToolTip As String = "Previous Page"

	Private nextPageText As String = ""
	Private nextPageToolTip As String = "Next Page"

	Private firstPageText As String = "First"
	Private firstPageToolTip As String = "First Page"

	Private lastPageText As String = "Last"
	Private lastPageToolTip As String = "Last Page"

	Private fromPageLink As Integer
	Private toPageLink As Integer


#Region " Web Form Designer Generated Code "

	'This call is required by the Web Form Designer.
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

	End Sub

	'NOTE: The following placeholder declaration is required by the Web Form Designer.
	'Do not delete or move it.
	Private designerPlaceholderDeclaration As System.Object

	Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
		'CODEGEN: This method call is required by the Web Form Designer
		'Do not modify it using the code editor.
		InitializeComponent()
	End Sub

#End Region

	' Public Methods

	Public Sub FillPager()
		InitializePager()
		SetPagerItems()
		LinkSelector1.SelectedItem = (ConnectedGrid.CurrentPageIndex + 1).ToString()
	End Sub

	' Private Methods

	Private Sub InitializePager()
		' Establish from - to page links
		fromPageLink = ((ConnectedGrid.CurrentPageIndex \ PageLinksPerSection) * PageLinksPerSection) + 1
		toPageLink = fromPageLink + PageLinksPerSection - 1

		If toPageLink > NumberOfPages Then
			toPageLink = NumberOfPages
		End If
		' Disable pager when grid is in Edit mode (not needed, but probably more user friendly)
		LinkSelector1.Enabled = ConnectedGrid.CurrentMode <> "formedit"
	End Sub

	Private Sub SetPagerItems()
		' Set LinkSelector Items

		' Clear and fill the items on each postback.
		LinkSelector1.LinkItems.Clear()

		' Only fill LinkSelector if number of pages is > 1 as it does not make much sense 
		' to have 0 or 1 page items in the pager.
		If NumberOfPages > 1 Then

			' First page
			Dim liFirst As New Axezz.WebGadgets.LinkItem(firstPageText)
			liFirst.ToolTip = firstPageToolTip
			LinkSelector1.LinkItems.Add(liFirst)

			' Previous page
			Dim liPrevious As New Axezz.WebGadgets.LinkItem(previousPageText)
			liPrevious.ToolTip = previousPageToolTip
			liPrevious.Enabled = (ConnectedGrid.CurrentPageIndex > 0)
			LinkSelector1.LinkItems.Add(liPrevious)

			' Page number links
			For i As Integer = fromPageLink To toPageLink
				LinkSelector1.LinkItems.Add(New Axezz.WebGadgets.LinkItem(i.ToString()))
			Next

			' Next page
			Dim liNext As New Axezz.WebGadgets.LinkItem(nextPageText)
			liNext.ToolTip = nextPageToolTip
			liNext.Enabled = (ConnectedGrid.CurrentPageIndex < (NumberOfPages) - 1)
			LinkSelector1.LinkItems.Add(liNext)

			' Last page
			Dim liLast As New Axezz.WebGadgets.LinkItem(lastPageText)
			liLast.ToolTip = lastPageToolTip
			LinkSelector1.LinkItems.Add(liLast)
		End If
	End Sub

	Private Sub LinkSelector1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles LinkSelector1.Click
		If LinkSelector1.SelectedItem = firstPageText Then
			ConnectedGrid.CurrentPageIndex = 0
		ElseIf LinkSelector1.SelectedItem = previousPageText Then
			ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex - 1
		ElseIf LinkSelector1.SelectedItem = nextPageText Then
			ConnectedGrid.CurrentPageIndex = ConnectedGrid.CurrentPageIndex + 1
		ElseIf LinkSelector1.SelectedItem = lastPageText Then
			ConnectedGrid.CurrentPageIndex = NumberOfPages - 1
		Else
			ConnectedGrid.CurrentPageIndex = Integer.Parse(LinkSelector1.SelectedItem) - 1
		End If
	End Sub
End Class
